Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/JsonItemVMBase.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/JsonItemVMBase.cs	(revision 17411)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/JsonItemVMBase.cs	(revision 17412)
@@ -22,12 +22,4 @@
 
     public virtual Type JsonItemType => typeof(JsonItem);
-
-    //protected IJsonItemValueParser Parser { get; set; }
-    //child tree
-    //private IList<JsonItemVM> nodes = new List<JsonItemVM>();
-
-    //public IEnumerable<JsonItemVM> Nodes { get => nodes; }
-    //public JsonItemVM Parent { get; private set; }
-
 
     private bool selected = true;
@@ -55,4 +47,5 @@
       }
     }
+
     public virtual JsonItemBaseControl GetControl() {
       return new JsonItemBaseControl(this);
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/RangeVM.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/RangeVM.cs	(revision 17411)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/RangeVM.cs	(revision 17412)
@@ -21,7 +21,7 @@
 
     public T MinValue {
-      get => Cast(((Array)base.Item.Value).GetValue(0));
+      get => Cast(((Array)Item.Value).GetValue(0));
       set {
-        SetValue(value, ((Array)base.Item.Value).GetValue(1));
+        SetValue(value, ((Array)Item.Value).GetValue(1));
         OnPropertyChange(this, nameof(MinValue));
       }
@@ -29,7 +29,7 @@
 
     public T MaxValue {
-      get => Cast(((Array)base.Item.Value).GetValue(1));
+      get => Cast(((Array)Item.Value).GetValue(1));
       set {
-        SetValue(((Array)base.Item.Value).GetValue(0), value);
+        SetValue(((Array)Item.Value).GetValue(0), value);
         OnPropertyChange(this, nameof(MaxValue));
       }
@@ -37,7 +37,7 @@
 
     public T MinRange {
-      get => Cast(base.Item.Range.First());
+      get => Cast(Item.Range.First());
       set {
-        SetRange(value, base.Item.Range.Last());
+        SetRange(value, Item.Range.Last());
         OnPropertyChange(this, nameof(MinRange));
       }
@@ -45,7 +45,7 @@
 
     public T MaxRange {
-      get => Cast(base.Item.Range.Last());
+      get => Cast(Item.Range.Last());
       set {
-        SetRange(base.Item.Range.First(), value);
+        SetRange(Item.Range.First(), value);
         OnPropertyChange(this, nameof(MaxRange));
       }
@@ -55,8 +55,8 @@
 
     private void SetValue(object min, object max) =>
-      base.Item.Value = new object[] { min, max };
+      Item.Value = new object[] { min, max };
 
     private void SetRange(object min, object max) =>
-      base.Item.Range = new object[] { min, max };
+      Item.Range = new object[] { min, max };
   }
 }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/SingleValueVM.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/SingleValueVM.cs	(revision 17411)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/SingleValueVM.cs	(revision 17412)
@@ -41,7 +41,7 @@
     
     public T Value { 
-      get => Cast(base.Item.Value);
+      get => Cast(Item.Value);
       set {
-        base.Item.Value = value;
+        Item.Value = value;
         OnPropertyChange(this, nameof(Value));
       }
@@ -49,7 +49,7 @@
 
     public T MinRange {
-      get => Cast(base.Item.Range.First());
+      get => Cast(Item.Range.First());
       set {
-        SetRange(value, base.Item.Range.Last());
+        SetRange(value, Item.Range.Last());
         OnPropertyChange(this, nameof(MinRange));
       }
@@ -57,7 +57,7 @@
 
     public T MaxRange {
-      get => Cast(base.Item.Range.Last());
+      get => Cast(Item.Range.Last());
       set {
-        SetRange(base.Item.Range.First(), value);
+        SetRange(Item.Range.First(), value);
         OnPropertyChange(this, nameof(MaxRange));
       }
@@ -90,5 +90,5 @@
     private void SetRange(object min, object max) {
       object[] range = new object[] { min, max };
-      base.Item.Range = range;
+      Item.Range = range;
     }
 
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/StringValueVM.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/StringValueVM.cs	(revision 17411)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/StringValueVM.cs	(revision 17412)
@@ -12,7 +12,7 @@
 
     public string Value {
-      get => base.Item.Value.ToString();
+      get => Item.Value.ToString();
       set {
-        base.Item.Value = value;
+        Item.Value = value;
         OnPropertyChange(this, nameof(Value));
       }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.cs	(revision 17411)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.cs	(revision 17412)
@@ -78,5 +78,5 @@
       }
 
-      this.Close();
+      Close();
     }
 
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemBoolControl.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemBoolControl.cs	(revision 17411)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemBoolControl.cs	(revision 17412)
@@ -17,11 +17,5 @@
       VM = vm;
       checkBoxValue.DataBindings.Add("Checked", VM, nameof(BoolValueVM.Value));
-      //checkBoxValue.Checked = (bool)vm.Item.Value;
     }
-    /*
-    private void checkBoxValue_CheckStateChanged(object sender, EventArgs e) {
-      VM.Item.Value = checkBoxValue.Checked;
-    }
-    */
   }
 }