Index: /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 17414)
+++ /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 17415)
@@ -179,4 +179,7 @@
     <Compile Include="Regression\Physics\RocketFuelFlow.cs" />
     <Compile Include="Regression\UCITimeSeries\GasFlowModulation.cs" />
+    <Compile Include="Regression\UCITimeSeries\HydraulicConditionMonitoring.cs" />
+    <Compile Include="Regression\UCITimeSeries\SocialMediaBuzzTomsHardware.cs" />
+    <Compile Include="Regression\UCITimeSeries\SocialMediaBuzzTwitter.cs" />
     <Compile Include="Regression\UCITimeSeries\UCITimeSeriesProvider.cs" />
     <Compile Include="Regression\VariableNetworks\LinearVariableNetwork.cs" />
Index: /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/UCITimeSeries/GasFlowModulation.cs
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/UCITimeSeries/GasFlowModulation.cs	(revision 17414)
+++ /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/UCITimeSeries/GasFlowModulation.cs	(revision 17415)
@@ -20,10 +20,8 @@
 #endregion
 
-
 using System.Linq;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class GasFlowModulation : ResourceRegressionDataDescriptor {
-
     public GasFlowModulation()
     : base("GasFlowModulation.csv") { }
Index: /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/UCITimeSeries/HydraulicConditionMonitoring.cs
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/UCITimeSeries/HydraulicConditionMonitoring.cs	(revision 17415)
+++ /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/UCITimeSeries/HydraulicConditionMonitoring.cs	(revision 17415)
@@ -0,0 +1,54 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class HydraulicConditionMonitoring : ResourceRegressionDataDescriptor {
+    public HydraulicConditionMonitoring()
+      : base("HydraulicConditionMonitoring.csv") { }
+
+    public override string Name { get { return "Hydraulic Condition Monitoring"; } }
+    public override string Description { get { return "The data set addresses the condition assessment of a hydraulic test rig based on multi sensor data. Four fault types are superimposed with several severity grades impeding selective quantification."; } }
+    protected override string TargetVariable { get { return "Cooler condition"; } }  // or  "Valve condition", "Internal pump leakage", "Hydraulic accumulator"
+    protected override string[] VariableNames {
+      get { return AllowedInputVariables.Concat(new[] { "Cooler condition", "Valve condition", "Internal pump leakage", "Hydraulic accumulator", "stable flag" }).ToArray(); }
+    }
+    protected override string[] AllowedInputVariables {
+      get {
+        return new[] {
+          "PS1", "PS2", "PS3", "PS4", "PS5", "PS6",
+          "EPS1",
+          "FS1", "FS2",
+          "TS1", "TS2", "TS3", "TS4",
+          "VS1",
+          "CE",
+          "CP",
+          "SE"
+        };
+      }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 1470; } }
+    protected override int TestPartitionStart { get { return 1470; } }
+    protected override int TestPartitionEnd { get { return 2205; } }
+  }
+}
Index: /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/UCITimeSeries/SocialMediaBuzzTomsHardware.cs
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/UCITimeSeries/SocialMediaBuzzTomsHardware.cs	(revision 17415)
+++ /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/UCITimeSeries/SocialMediaBuzzTomsHardware.cs	(revision 17415)
@@ -0,0 +1,58 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class SocialMediaBuzzTomsHardware : ResourceRegressionDataDescriptor {
+    public SocialMediaBuzzTomsHardware()
+      : base("SocialMediaBuzz(TomsHardware).csv") { }
+
+    public override string Name { get { return "Social Media Buzz (TomsHardware)"; } }
+    public override string Description { get { return "This data-set contains examples of buzz events from Tom's Hardware, a forum network focusing on new technology with more conservative dynamics."; } }
+    protected override string TargetVariable { get { return "Mean Number of display (ND)"; } }
+    protected override string[] VariableNames {
+      get { return AllowedInputVariables.Concat(new[] { "Mean Number of display (ND)" }).ToArray(); }
+    }
+    protected override string[] AllowedInputVariables {
+      get {
+        return new[] {
+          "Number of Created Discussions (NCD)",
+          "Burstiness Level (BL)",
+          "Average Discussions Length (NAD)",
+          "Author Increase (AI)",
+          "Number of Atomic Containers (NAC)",
+          "Number of displays (ND)",
+          "Contribution Sparseness (CS)",
+          "Author Interaction (AT)",
+          "Number of Authors (NA)",
+          "Average Discussions Length (ADL)",
+          "Attention Level (measured with number of authors) (AS(NA))",
+          "Attention Level (measured with number of contributions) (AS(NAC))"
+        };
+      }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 18786; } }
+    protected override int TestPartitionStart { get { return 18786; } }
+    protected override int TestPartitionEnd { get { return 28179; } }
+  }
+}
Index: /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/UCITimeSeries/SocialMediaBuzzTwitter.cs
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/UCITimeSeries/SocialMediaBuzzTwitter.cs	(revision 17415)
+++ /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/UCITimeSeries/SocialMediaBuzzTwitter.cs	(revision 17415)
@@ -0,0 +1,57 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class SocialMediaBuzzTwitter : ResourceRegressionDataDescriptor {
+    public SocialMediaBuzzTwitter()
+      : base("SocialMediaBuzz(Twitter).csv") { }
+
+    public override string Name { get { return "Social Media Buzz (Twitter)"; } }
+    public override string Description { get { return "This data-set contains examples of buzz events from Twitter."; } }
+    protected override string TargetVariable { get { return "Mean Number of active discussion (NAD)"; } }
+    protected override string[] VariableNames {
+      get { return AllowedInputVariables.Concat(new[] { "Mean Number of active discussion (NAD)" }).ToArray(); }
+    }
+    protected override string[] AllowedInputVariables {
+      get {
+        return new[] {
+          "Number of Created Discussions (NCD)",
+          "Author Increase (AI)",
+          "Attention Level (measured with number of authors) (AS(NA))",
+          "Burstiness Level (BL)",
+          "Number of Atomic Containers (NAC)",
+          "Attention Level (measured with number of contributions) (AS(NAC)",
+          "Contribution Sparseness (CS)",
+          "Author Interaction (AT)",
+          "Number of Authors (NA)",
+          "Average Discussions Length (ADL)",
+          "Average Discussions Length (NAD)"
+        };
+      }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 388834; } }
+    protected override int TestPartitionStart { get { return 388834; } }
+    protected override int TestPartitionEnd { get { return 583250; } }
+  }
+}
Index: /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/UCITimeSeries/UCITimeSeriesProvider.cs
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/UCITimeSeries/UCITimeSeriesProvider.cs	(revision 17414)
+++ /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/UCITimeSeries/UCITimeSeriesProvider.cs	(revision 17415)
@@ -48,5 +48,10 @@
 
     public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
-      yield return new GasFlowModulation();
+      return new IDataDescriptor[] {
+        new GasFlowModulation(),
+        new HydraulicConditionMonitoring(),
+        new SocialMediaBuzzTwitter(),
+        new SocialMediaBuzzTomsHardware()
+      };
     }
 